//+------------------------------------------------------------------+
//|                                                CompareProfit.mq5 |
//|                        Copyright 2018, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#include <ProfitMeter2.mqh>
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   
//---
   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   
   //Get All opened positions
   for(int i=0;i<PositionsTotal();i++){   
      if(PositionGetTicket(i)){
         
         //Calcuate position profit using PointValue();
         double getOrderProfit=GetOrderProfit((ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE),PositionGetString(POSITION_SYMBOL),
            PositionGetDouble(POSITION_VOLUME),PositionGetDouble(POSITION_PRICE_OPEN),PositionGetDouble(POSITION_PRICE_CURRENT));
         
         //Calcuate position profit using MT5 OrderCalcProfit();
         double orderCalcProfit=0;
         bool val=OrderCalcProfit((ENUM_ORDER_TYPE)PositionGetInteger(POSITION_TYPE),PositionGetString(POSITION_SYMBOL),
            PositionGetDouble(POSITION_VOLUME),PositionGetDouble(POSITION_PRICE_OPEN),PositionGetDouble(POSITION_PRICE_CURRENT),orderCalcProfit);
         
         //Compare results
         if(DoubleToString(getOrderProfit,2)!=DoubleToString(orderCalcProfit,2))
            Print("OnTick(): Symbol: "+PositionGetString(POSITION_SYMBOL)+
               " GetOrderProfit() = "+DoubleToString(getOrderProfit,8)+"; OrderCalcProfit() = "+DoubleToString(orderCalcProfit,8)); 
         
         }
      }
  }
   
double GetOrderProfit(ENUM_POSITION_TYPE positionType,string symbol, double volume, double price_open, double price_close){
   double profit =  volume * (price_close - price_open) / SymbolInfoDouble(symbol,SYMBOL_POINT) * PointValue(symbol, positionType == POSITION_TYPE_SELL);
   if(positionType==POSITION_TYPE_SELL)profit*=-1;
   return profit;
   }